



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>AlwaysON同步性能监控的三板斧</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">AlwaysON同步性能监控的三板斧</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-12 19:33:17 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>延迟是AlwaysOn最大的敌人之一</h1>
<p>延迟是AlwaysON的最大敌人之一。对AlwaysON而言，其首要目标就尽量减少（无法避免）主副本、辅助副本的数据延迟，实现主副本、辅助副本的&ldquo;数据同步&rdquo;。只有主副本、辅助副本的同步延迟越小越高，只读访问的实性性才会越高，数据库的RTO（<a href="http://technet.microsoft.com/en-us/library/dn135338(v=sql.110).aspx#bkmk_rto" rel="external nofollow noreferrer">Estimating Failover Time</a>）和RPO（<a href="http://technet.microsoft.com/en-us/library/dn135338(v=sql.110).aspx#bkmk_rpo" rel="external nofollow noreferrer">Estimating Potential Data Loss</a>）也才会越小。</p>
<p>但延迟可能存在于AlwaysON同步的各个环节中，因此，在分析现延迟情况时，应该首先理解AlwaysON的同步过程，然后切分到每个过程中进行监控和分析。</p>
<h1>AlwaysON同步的6大步骤</h1>
<p>在我的上篇文章《AlwaysON的同步原理及同步模式》中，曾介绍过AlwaysON的同步过程。归结起来，主要包括如下六个步骤：</p>
<p>① log flush(primary)</p>
<p>② log capture(primary)</p>
<p>③ send(primary and secondary)</p>
<p>④ log receive and cache(secondary)</p>
<p>⑤ log hardened(secondary)</p>
<p>⑥ redo(secondary)</p>
<p>前两个步骤发生在主副本，最后三个步骤发生在辅助副本，中间的第三个步骤发生主副本和辅助副本之间。</p>
<p>另外，如果是同步提交模式，还需要增加一个步骤：辅助副本在步骤5之后，会发送一个（日志硬化）确认信息给主副本，然后才能进入redo阶段。</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/458366/201412/022000123119344.png" /></p>
<h1>监控AlwaysOn的同步过程</h1>
<h2>Log Flush(Primary)</h2>
<p>Log Flush就是将log buffer中的日志刷入到磁盘中。在SQL Server中，log buffer的大小固定为60KB，当发生事务提交时、checkpoint、或者buffer可用空间不足时，日志就会被flush磁盘中。</p>
<p>AlwaysON只有待主副本的日志刷入磁盘后才能继续后面的步骤（为了保护主副本的数据一致性）。因此，log flush的越快，AlwaysON后续步骤进入的就越早，延迟就越小，反之亦然。</p>
<p>那么，在这个阶段中，如何监控log flush的速度和性能呢？通常，我们使用如下两个性能计数器：</p>
<ul><li>Avg. Disk sec/Write</li></ul>
<p>这是一个磁盘的性能计数器，这个指标反映的是flush期间磁盘的写操作的平均响应时间，如果10ms以内，说明磁盘性能非常好，如果在10ms到20ms，说明性能较好，如果在20ms到50ms说明性能较差，如果在50ms以上，说明性能很差。</p>
<ul><li><a href="http://technet.microsoft.com/en-us/library/ms189883(v=sql.110).aspx" rel="external nofollow noreferrer">SQL Server:Database &gt; Log bytes flushed\sec</a></li></ul>
<p>这个指标直接反映了每秒flush的日志大小，因在不同的时段、不同的业务中日志产生的大小可能不同，因此不能提供一个标准值用来衡量flush性能的好坏，不过，当这个值很大时，说明数据库操作（增、删、改）比较频繁，需要引起注意，结合后续步骤中的其他指标一起分析。</p>
<h2>log capture(primary)</h2>
<p>log capture发生在log flush之后，是AlwaysON中最重要的阶段（个人认为）。在这个阶段中，主副本上会为每个辅助副本维护一个发送队列，队列的内容就是从日志缓冲或者磁盘中capture的日志，而队列的大小则反映了主副本和辅助副本数据不同步的差量。</p>
<p>显然，在这个阶段最可能影响AlwaysON同步性能的两个关键因素就是：capture日志的来源（是磁盘还是内存）和队列的大小。</p>
<p>在上述两个因素中，我需要着重解释下capture日志的来源：是磁盘还是内存？我们自导，从内存中读取数据效率要远远高于从磁盘中读取，所以在AlwaysON中，SQL Server会尽可能多将日志缓冲到内存中。但缓冲的大小是有限的，如果日志量太大、缓冲的大小不足，则不得不读取磁盘。</p>
<p>下面我们来熟悉下如何监控日志的来源和发送队列的大小：</p>
<p><strong>监控日志的来源：</strong></p>
<p>日志到底是读取自内存还是磁盘，通过如下性能计数器可窥见一斑：</p>
<ul><li>SQL Server:Databases:Log Pool Requests/sec和SQL Server:Memory Manager:Log Pool Memory (KB)</li></ul>
<p>解释：前者表示每秒中从内存中请求日志块的数量；后者表示log pool memory的大小；</p>
<p>说明：对于这两个值，我们希望越高越好，则说明越多的日志可以从内存中读取到。</p>
<ul><li>SQL Server:Databases:Log Pool Disk Reads/sec和SQL Server:Databases:Log Pool Cache Misses/sec</li></ul>
<p>解释：两个性能计数器其实都表示内存中找不到要读取的日志，必须从磁盘中读取；</p>
<p>说明：如果两个值越高，说明内存性能不足，SQL Server没法缓冲更多的日志。</p>
<p><strong>监控日志发送队列：</strong></p>
<p>在主副本上执行如下语句即可：</p>
<p>SELECT ag.name AS ag_name, ar.replica_server_name AS ag_replica_server, dr_state.database_id as database_id,</p>
<p>dr_state.log_send_queue_size, is_ag_replica_local = CASE</p>
<p>WHEN ar_state.is_local = 1 THEN N'LOCAL'</p>
<p>ELSE 'REMOTE'</p>
<p>END ,</p>
<p>ag_replica_role = CASE</p>
<p>WHEN ar_state.role_desc IS NULL THEN N'DISCONNECTED'</p>
<p>ELSE ar_state.role_desc</p>
<p>END</p>
<p>FROM (( sys.availability_groups AS ag JOIN sys.availability_replicas AS ar ON ag.group_id = ar.group_id )</p>
<p>JOIN sys.dm_hadr_availability_replica_states AS ar_state ON ar.replica_id = ar_state.replica_id)</p>
<p>JOIN sys.dm_hadr_database_replica_states dr_state on</p>
<p>ag.group_id = dr_state.group_id and dr_state.replica_id = ar_state.replica_id;</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/458366/201412/022000262807177.png" /></p>
<p>log_send_queue_size表示主数据库中尚未发送到辅助数据库的日志记录量 (KB)，也就是上文说的发送队列，如果某个辅助副本的发送队列持续增加，说明此副本与主副本同步的数据差量就越大。</p>
<p>在上例中，server1是主副本，server2是辅助副本。主副本的log_send_queue_size始终为null，server2的log_send_queue_size为154067KB。显然，此时server2明显落后于主副本。</p>
<h2>send(primary and secondary)</h2>
<p>send阶段是 AlwaysON同步过程中最简单的一个步骤（个人认为）。在这个阶段中，我们主要关注网络性能就好了，因为主副本必须借助网络才能把发送队列的日志传输到到对应的辅助副本。如果网络不好，AlwaysON就会产生延迟，更有甚者，如果是在同步提交模式下，还会导致主副本的事务迟迟不能提交。</p>
<p>对网络的监控主要通过如下两个性能计数器即可：</p>
<ul><li>Network Interface:bytes sent/sec</li></ul>
<p>解释：网卡每秒发送的字节数；</p>
<p>说明：对于这个指标我们不能孤立来看，需结合发送队列的大小，当发送队列很大，但此性能指标持续比较低时，有可能是网络有问题（当然，如果是同步模式，需要考虑辅助副本log harden的速度才能决定是否一定跟网络有关）。</p>
<ul><li>Network Interface:output Queue Length</li></ul>
<p>解释：网卡的发送队列大小；</p>
<p>说明：一般来说，网卡的队列大于2时，说明网络存在拥堵，可能出现了网络问题。</p>
<h2>Log Receive and cache(sencondary)</h2>
<p>log receive and cache发生在辅助副本上，表示辅助副本接受来自主副本发送的日志块、并缓冲起来的过程。</p>
<p>这个阶段其实跟网络速度和内存大小有关，两者在上文中均有介绍，这里不做过多阐述，只跟大家介绍下这个阶段中AlwaysON专有性能计数器。</p>
<ul><li><a href="http://technet.microsoft.com/en-us/library/ff878472(v=sql.110).aspx" rel="external nofollow noreferrer">SQL Server:Availabiltiy Replica &gt; Log Bytes Received/sec</a></li></ul>
<p>解释：每秒接受的日志大小（单位为KB）；</p>
<p>说明：接受的速度越快，说明网络性能和内存性能均越好。</p>
<h2>Log Hardened(sencondary)</h2>
<p>介绍log hardened时不得不谈一谈第一个步骤的log flush，两者其实是一个东西，只是表述不一样。因为它们无论是工作原理还是对事务提交的影响都非常类似，因此对log hardened的监控，直接参考步骤一就好了。</p>
<h2>redo(secondary)</h2>
<p>redo的对象是辅助副本中已经固化的日志（该日志可能是内存中副本，也可能来自磁盘上），是AlwaysON中&ldquo;实现&rdquo;数据同步的步骤，其他步骤都是为此做铺垫，即便是上个步骤的日志固化，它也只能保证主副本和辅助副本的数据一致，而真正的数据同步必须等待辅助副本的redo完成。</p>
<p>在这个阶段中，有两个因素决定了数据延迟的大小：redo的日志大小和redo的速度。下面我们从这两个角度来了解下redo阶段的性能监控：</p>
<p><strong>监控redo</strong><strong>日志大小</strong></p>
<p>SELECT ag.name AS ag_name, ar.replica_server_name AS ag_replica_server, dr_state.database_id as database_id,</p>
<p>dr_state.redo_queue_size, is_ag_replica_local = CASE</p>
<p>WHEN ar_state.is_local = 1 THEN N'LOCAL'</p>
<p>ELSE 'REMOTE'</p>
<p>END ,</p>
<p>ag_replica_role = CASE</p>
<p>WHEN ar_state.role_desc IS NULL THEN N'DISCONNECTED'</p>
<p>ELSE ar_state.role_desc</p>
<p>END</p>
<p>FROM (( sys.availability_groups AS ag JOIN sys.availability_replicas AS ar ON ag.group_id = ar.group_id )</p>
<p>JOIN sys.dm_hadr_availability_replica_states AS ar_state ON ar.replica_id = ar_state.replica_id)</p>
<p>JOIN sys.dm_hadr_database_replica_states dr_state on</p>
<p>ag.group_id = dr_state.group_id and dr_state.replica_id = ar_state.replica_id;</p>
<p><strong>监控redo</strong><strong>的速度</strong></p>
<p>redo的速度通过如下性能计数器即可：</p>
<ul><li><a href="http://technet.microsoft.com/en-us/library/ff878356(v=sql.110).aspx" rel="external nofollow noreferrer">SQL Server:Database Replica &gt; Redone Bytes/sec</a></li></ul>
<p>解释：辅助副本每秒完成redo的字节数；</p>
<p>说明：在分析此指标时，必须结合redo的日志大小，将两者的结果相除可得到一个大致的同步延迟时间。</p>
<h1>结尾</h1>
<p>我们知道AlwaysON是SQL Server 2012才开始引入的技术，目前笔者做的案例还不是很多，本文所表述的内容都是基于我有限的实践经验总结而来，如有不妥之处还请批评指正。</p>
<p>附上我的新浪微博二维码，希望我的分享能够为您带来一些价值。</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/458366/201412/052009594675704.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39rgdpd8.html">ubuntu系统theano和keras的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyre4j8.html">oracle&colon;ORACLE 实际返回的行数超出请求的行数</a>
		</li>
						<li><a href="https://www.batexi.com/a/495l7z08.html">在MySQL中存储大文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m1e428.html">IntelliJ IDEA 的SVN配置与使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g23ml8.html">C&num; 改变无边框窗体的尺寸大小</a>
		</li>
						<li><a href="https://www.batexi.com/a/96orxdv9.html">CentOS 7 之Shell学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn3kprq.html">UESTC&lowbar;菲波拉契数制升级版 2015 UESTC Training for Dynamic Programming&amp;lt&semi;Problem L&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn170n28.html">一起talk GDB吧（第七回：GDB监视功能）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd61zy8.html">监听enter事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmzywk9.html">1&lowbar;HelloWorld</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j5z1o8.html">C&num;计算两个文件的相对目录算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1gkexq.html">ThinkSNS积分商城系统功能详解！</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljwymk9.html">python---os模块使用详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z1og09.html">LM算法与非线性最小二乘问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyygpyjq.html">Python：将数组中的元素导出到变量中 &lpar;unpacking&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy26kx9.html">js设置div透明度</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zypz119.html">Vue 温故而知新 props如何双向属性绑定</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjwver8.html">Eletron 打开文件夹，截图</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o47yrlq.html">如何编译Linux内核</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mdj5yp8.html">白话控制反转IoC及其应用</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9p475y9.html">NDK相关以及同步相关博客收集</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvy3ejq.html">济南学习D2T2&lowbar;&lowbar;数学分析题</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q753gk9.html">MySQL表分区</a>
			</li>
						<li><a href="https://www.batexi.com/a/r934ryg8.html">Odoo10尝鲜： 退货</a>
			</li>
						<li><a href="https://www.batexi.com/a/495ely09.html">hibernate多表查询，结果封装在自己定义的一个实体类当中（在自己定义的类中增加构造函数）</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnx6px9.html">JAVA -Xms -Xmx -XX&colon;PermSize -XX&colon;MaxPermSize 区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96rnpv9.html">RHEL查看CPU等机器信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zz7vx8.html">jquery load 加载改造，只加载body</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96rnyj9.html">设置IE8 多个Table只产生一个进程</a>
			</li>
						<li><a href="https://www.batexi.com/a/495e1v09.html">Android入门</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
